/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Computes the one-argument inverse tangent of each pixel.


This filter is templated over the pixel type of the input image and
the pixel type of the output image.

The filter walks over all the pixels in the input image, and for each
pixel does the following:


cast the pixel value to double ,

apply the std::atan() function to the double value,

cast the double value resulting from std::atan() to the pixel type of
the output image,

store the cast value into the output image.
See:
 itk::simple::Atan for the procedural interface

 itk::AtanImageFilter for the Doxygen on the original ITK class.



C++ includes: sitkAtanImageFilter.h
*/
public class AtanImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected AtanImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.AtanImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(AtanImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(AtanImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::AtanImageFilter::~AtanImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_AtanImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::AtanImageFilter::AtanImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  AtanImageFilter() {
    this(SimpleITKJNI.new_AtanImageFilter(), true);
  }

  /**
std::string itk::simple::AtanImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.AtanImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::AtanImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.AtanImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::AtanImageFilter::Execute(Image &amp;&amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.AtanImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
