/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Remove holes not connected to the boundary of the image.


BinaryFillholeImageFilter fills holes in a binary image.

Geodesic morphology and the Fillhole algorithm is described in Chapter
6 of Pierre Soille's book "Morphological Image Analysis: Principles
and Applications", Second Edition, Springer, 2003.


Gaetan Lehmann. Biologie du Developpement et de la Reproduction, INRA
de Jouy-en-Josas, France.
 This implementation was taken from the Insight Journal paper: https://www.insight-journal.org/browse/publication/176


See:
 GrayscaleFillholeImageFilter

 itk::simple::BinaryFillhole for the procedural interface

 itk::BinaryFillholeImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkBinaryFillholeImageFilter.h
*/
public class BinaryFillholeImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected BinaryFillholeImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.BinaryFillholeImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(BinaryFillholeImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(BinaryFillholeImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::BinaryFillholeImageFilter::~BinaryFillholeImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_BinaryFillholeImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::BinaryFillholeImageFilter::BinaryFillholeImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  BinaryFillholeImageFilter() {
    this(SimpleITKJNI.new_BinaryFillholeImageFilter(), true);
  }

  /**
Self&amp; itk::simple::BinaryFillholeImageFilter::SetFullyConnected(bool FullyConnected)

Set/Get whether the connected components are defined strictly by face
connectivity or by face+edge+vertex connectivity. Default is
FullyConnectedOff. For objects that are 1 pixel wide, use
FullyConnectedOn.

*/
public  void setFullyConnected(boolean FullyConnected) {
    SimpleITKJNI.BinaryFillholeImageFilter_setFullyConnected(swigCPtr, this, FullyConnected);
  }

  /**
Self&amp; itk::simple::BinaryFillholeImageFilter::FullyConnectedOn()

Set the value of FullyConnected to true or false respectfully.

*/
public  void fullyConnectedOn() {
    SimpleITKJNI.BinaryFillholeImageFilter_fullyConnectedOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BinaryFillholeImageFilter::FullyConnectedOff()
*/
public  void fullyConnectedOff() {
    SimpleITKJNI.BinaryFillholeImageFilter_fullyConnectedOff(swigCPtr, this);
  }

  /**
bool itk::simple::BinaryFillholeImageFilter::GetFullyConnected() const

Set/Get whether the connected components are defined strictly by face
connectivity or by face+edge+vertex connectivity. Default is
FullyConnectedOff. For objects that are 1 pixel wide, use
FullyConnectedOn.

*/
public  boolean getFullyConnected() {
    return SimpleITKJNI.BinaryFillholeImageFilter_getFullyConnected(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BinaryFillholeImageFilter::SetForegroundValue(double ForegroundValue)

Set the value in the image to consider as "foreground". Defaults to
maximum value of InputPixelType.

*/
public  void setForegroundValue(double ForegroundValue) {
    SimpleITKJNI.BinaryFillholeImageFilter_setForegroundValue(swigCPtr, this, ForegroundValue);
  }

  /**
double itk::simple::BinaryFillholeImageFilter::GetForegroundValue() const

Get the value in the image considered as "foreground". Defaults to
maximum value of InputPixelType.

*/
public  double getForegroundValue() {
    return SimpleITKJNI.BinaryFillholeImageFilter_getForegroundValue(swigCPtr, this);
  }

  /**
std::string itk::simple::BinaryFillholeImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.BinaryFillholeImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::BinaryFillholeImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.BinaryFillholeImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::BinaryFillholeImageFilter::Execute(const Image &amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.BinaryFillholeImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
