/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Remove the objects not connected to the boundary of the image.


BinaryGrindPeakImageFilter grinds peaks in a grayscale image.

Geodesic morphology and the grind peak algorithm is described in
Chapter 6 of Pierre Soille's book "Morphological Image Analysis:
Principles and Applications", Second Edition, Springer, 2003.


Gaetan Lehmann. Biologie du Developpement et de la Reproduction, INRA
de Jouy-en-Josas, France.
 This implementation was taken from the Insight Journal paper: https://www.insight-journal.org/browse/publication/176


See:
 GrayscaleGrindPeakImageFilter

 itk::simple::BinaryGrindPeak for the procedural interface

 itk::BinaryGrindPeakImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkBinaryGrindPeakImageFilter.h
*/
public class BinaryGrindPeakImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected BinaryGrindPeakImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.BinaryGrindPeakImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(BinaryGrindPeakImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(BinaryGrindPeakImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::BinaryGrindPeakImageFilter::~BinaryGrindPeakImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_BinaryGrindPeakImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::BinaryGrindPeakImageFilter::BinaryGrindPeakImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  BinaryGrindPeakImageFilter() {
    this(SimpleITKJNI.new_BinaryGrindPeakImageFilter(), true);
  }

  /**
Self&amp; itk::simple::BinaryGrindPeakImageFilter::SetFullyConnected(bool FullyConnected)

Set/Get whether the connected components are defined strictly by face
connectivity or by face+edge+vertex connectivity. Default is
FullyConnectedOff. For objects that are 1 pixel wide, use
FullyConnectedOn.

*/
public  void setFullyConnected(boolean FullyConnected) {
    SimpleITKJNI.BinaryGrindPeakImageFilter_setFullyConnected(swigCPtr, this, FullyConnected);
  }

  /**
Self&amp; itk::simple::BinaryGrindPeakImageFilter::FullyConnectedOn()

Set the value of FullyConnected to true or false respectfully.

*/
public  void fullyConnectedOn() {
    SimpleITKJNI.BinaryGrindPeakImageFilter_fullyConnectedOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BinaryGrindPeakImageFilter::FullyConnectedOff()
*/
public  void fullyConnectedOff() {
    SimpleITKJNI.BinaryGrindPeakImageFilter_fullyConnectedOff(swigCPtr, this);
  }

  /**
bool itk::simple::BinaryGrindPeakImageFilter::GetFullyConnected() const

Set/Get whether the connected components are defined strictly by face
connectivity or by face+edge+vertex connectivity. Default is
FullyConnectedOff. For objects that are 1 pixel wide, use
FullyConnectedOn.

*/
public  boolean getFullyConnected() {
    return SimpleITKJNI.BinaryGrindPeakImageFilter_getFullyConnected(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BinaryGrindPeakImageFilter::SetForegroundValue(double ForegroundValue)

Set the value in the image to consider as "foreground". Defaults to
maximum value of InputPixelType.

*/
public  void setForegroundValue(double ForegroundValue) {
    SimpleITKJNI.BinaryGrindPeakImageFilter_setForegroundValue(swigCPtr, this, ForegroundValue);
  }

  /**
double itk::simple::BinaryGrindPeakImageFilter::GetForegroundValue() const

Get the value in the image considered as "foreground". Defaults to
maximum value of InputPixelType.

*/
public  double getForegroundValue() {
    return SimpleITKJNI.BinaryGrindPeakImageFilter_getForegroundValue(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BinaryGrindPeakImageFilter::SetBackgroundValue(double BackgroundValue)

Set the value in eroded part of the image. Defaults to zero

*/
public  void setBackgroundValue(double BackgroundValue) {
    SimpleITKJNI.BinaryGrindPeakImageFilter_setBackgroundValue(swigCPtr, this, BackgroundValue);
  }

  /**
double itk::simple::BinaryGrindPeakImageFilter::GetBackgroundValue() const

Set the value in eroded part of the image. Defaults to zero

*/
public  double getBackgroundValue() {
    return SimpleITKJNI.BinaryGrindPeakImageFilter_getBackgroundValue(swigCPtr, this);
  }

  /**
std::string itk::simple::BinaryGrindPeakImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.BinaryGrindPeakImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::BinaryGrindPeakImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.BinaryGrindPeakImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::BinaryGrindPeakImageFilter::Execute(const Image &amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.BinaryGrindPeakImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
