/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Black top hat extracts local minima that are smaller than the
structuring element.


Black top hat extracts local minima that are smaller than the
structuring element. It subtracts the background from the input image.
The output of the filter transforms the black valleys into white
peaks.

Top-hats are described in Chapter 4.5 of Pierre Soille's book
"Morphological Image Analysis: Principles and Applications", Second
Edition, Springer, 2003.


Gaetan Lehmann. Biologie du Developpement et de la Reproduction, INRA
de Jouy-en-Josas, France.

See:
 itk::simple::BlackTopHat for the procedural interface

 itk::BlackTopHatImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkBlackTopHatImageFilter.h
*/
public class BlackTopHatImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected BlackTopHatImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.BlackTopHatImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(BlackTopHatImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(BlackTopHatImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::BlackTopHatImageFilter::~BlackTopHatImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_BlackTopHatImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::BlackTopHatImageFilter::BlackTopHatImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  BlackTopHatImageFilter() {
    this(SimpleITKJNI.new_BlackTopHatImageFilter(), true);
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SetKernelRadius(unsigned int value)

Set the values of the KernelRadius vector all to value

*/
public  void setKernelRadius(VectorUInt32 KernelRadius) {
    SimpleITKJNI.BlackTopHatImageFilter_setKernelRadius__SWIG_0(swigCPtr, this, VectorUInt32.getCPtr(KernelRadius), KernelRadius);
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SetKernelRadius(unsigned int value)

Set the values of the KernelRadius vector all to value

*/
public  void setKernelRadius(long value) {
    SimpleITKJNI.BlackTopHatImageFilter_setKernelRadius__SWIG_1(swigCPtr, this, value);
  }

  /**
std::vector&lt;unsigned int&gt; itk::simple::BlackTopHatImageFilter::GetKernelRadius() const

Get the radius of the kernel structuring element.

*/
public  VectorUInt32 getKernelRadius() {
    return new VectorUInt32(SimpleITKJNI.BlackTopHatImageFilter_getKernelRadius(swigCPtr, this), true);
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SetKernelType(KernelEnum KernelType)

Set the kernel or structuring element used for the morphology.

*/
public  void setKernelType(KernelEnum KernelType) {
    SimpleITKJNI.BlackTopHatImageFilter_setKernelType(swigCPtr, this, KernelType.swigValue());
  }

  /**
KernelEnum itk::simple::BlackTopHatImageFilter::GetKernelType() const

Get the kernel or structuring element used for the morphology.

*/
public  KernelEnum getKernelType() {
    return KernelEnum.swigToEnum(SimpleITKJNI.BlackTopHatImageFilter_getKernelType(swigCPtr, this));
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SetSafeBorder(bool SafeBorder)

A safe border is added to input image to avoid borders effects and
remove it once the closing is done

*/
public  void setSafeBorder(boolean SafeBorder) {
    SimpleITKJNI.BlackTopHatImageFilter_setSafeBorder(swigCPtr, this, SafeBorder);
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SafeBorderOn()

Set the value of SafeBorder to true or false respectfully.

*/
public  void safeBorderOn() {
    SimpleITKJNI.BlackTopHatImageFilter_safeBorderOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::BlackTopHatImageFilter::SafeBorderOff()
*/
public  void safeBorderOff() {
    SimpleITKJNI.BlackTopHatImageFilter_safeBorderOff(swigCPtr, this);
  }

  /**
bool itk::simple::BlackTopHatImageFilter::GetSafeBorder() const

A safe border is added to input image to avoid borders effects and
remove it once the closing is done

*/
public  boolean getSafeBorder() {
    return SimpleITKJNI.BlackTopHatImageFilter_getSafeBorder(swigCPtr, this);
  }

  /**
std::string itk::simple::BlackTopHatImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.BlackTopHatImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::BlackTopHatImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.BlackTopHatImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::BlackTopHatImageFilter::Execute(const Image &amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.BlackTopHatImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
