/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Change Sets of Labels.


This filter produces an output image whose pixels are either copied
from the input if they are not being changed or are rewritten based on
the change parameters

This filter is templated over the input image type and the output
image type.

The filter expect both images to have the same number of dimensions.


Tim Kelliher. GE Research, Niskayuna, NY.

This work was supported by a grant from DARPA, executed by the U.S.
Army Medical Research and Materiel Command/TATRC Assistance Agreement,
Contract::W81XWH-05-2-0059.

See:
 itk::simple::ChangeLabel for the procedural interface

 itk::ChangeLabelImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkChangeLabelImageFilter.h
*/
public class ChangeLabelImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected ChangeLabelImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.ChangeLabelImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(ChangeLabelImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(ChangeLabelImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::ChangeLabelImageFilter::~ChangeLabelImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_ChangeLabelImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::ChangeLabelImageFilter::ChangeLabelImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  ChangeLabelImageFilter() {
    this(SimpleITKJNI.new_ChangeLabelImageFilter(), true);
  }

  /**
Self&amp; itk::simple::ChangeLabelImageFilter::SetChangeMap(std::map&lt; double, double &gt; ChangeMap)

Set the entire change map

*/
public  void setChangeMap(DoubleDoubleMap ChangeMap) {
    SimpleITKJNI.ChangeLabelImageFilter_setChangeMap(swigCPtr, this, DoubleDoubleMap.getCPtr(ChangeMap), ChangeMap);
  }

  /**
std::map&lt;double,double&gt; itk::simple::ChangeLabelImageFilter::GetChangeMap() const
*/
public  DoubleDoubleMap getChangeMap() {
    return new DoubleDoubleMap(SimpleITKJNI.ChangeLabelImageFilter_getChangeMap(swigCPtr, this), true);
  }

  /**
std::string itk::simple::ChangeLabelImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.ChangeLabelImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::ChangeLabelImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.ChangeLabelImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::ChangeLabelImageFilter::Execute(Image &amp;&amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.ChangeLabelImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
