/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Grayscale closing of an image.


Close an image using grayscale morphology.

The structuring element is assumed to be composed of binary values
(zero or one). Only elements of the structuring element having values
&gt; 0 are candidates for affecting the center pixel.


See:
 MorphologyImageFilter , GrayscaleFunctionErodeImageFilter , BinaryErodeImageFilter

 itk::simple::GrayscaleMorphologicalClosing for the procedural interface

 itk::GrayscaleMorphologicalClosingImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkGrayscaleMorphologicalClosingImageFilter.h
*/
public class GrayscaleMorphologicalClosingImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected GrayscaleMorphologicalClosingImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(GrayscaleMorphologicalClosingImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(GrayscaleMorphologicalClosingImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::GrayscaleMorphologicalClosingImageFilter::~GrayscaleMorphologicalClosingImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_GrayscaleMorphologicalClosingImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::GrayscaleMorphologicalClosingImageFilter::GrayscaleMorphologicalClosingImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  GrayscaleMorphologicalClosingImageFilter() {
    this(SimpleITKJNI.new_GrayscaleMorphologicalClosingImageFilter(), true);
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SetKernelRadius(unsigned int value)

Set the values of the KernelRadius vector all to value

*/
public  void setKernelRadius(VectorUInt32 KernelRadius) {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_setKernelRadius__SWIG_0(swigCPtr, this, VectorUInt32.getCPtr(KernelRadius), KernelRadius);
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SetKernelRadius(unsigned int value)

Set the values of the KernelRadius vector all to value

*/
public  void setKernelRadius(long value) {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_setKernelRadius__SWIG_1(swigCPtr, this, value);
  }

  /**
std::vector&lt;unsigned int&gt; itk::simple::GrayscaleMorphologicalClosingImageFilter::GetKernelRadius() const

Get the radius of the kernel structuring element.

*/
public  VectorUInt32 getKernelRadius() {
    return new VectorUInt32(SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_getKernelRadius(swigCPtr, this), true);
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SetKernelType(KernelEnum KernelType)

Set the kernel or structuring element used for the morphology.

*/
public  void setKernelType(KernelEnum KernelType) {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_setKernelType(swigCPtr, this, KernelType.swigValue());
  }

  /**
KernelEnum itk::simple::GrayscaleMorphologicalClosingImageFilter::GetKernelType() const

Get the kernel or structuring element used for the morphology.

*/
public  KernelEnum getKernelType() {
    return KernelEnum.swigToEnum(SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_getKernelType(swigCPtr, this));
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SetSafeBorder(bool SafeBorder)

A safe border is added to input image to avoid borders effects and
remove it once the closing is done

*/
public  void setSafeBorder(boolean SafeBorder) {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_setSafeBorder(swigCPtr, this, SafeBorder);
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SafeBorderOn()

Set the value of SafeBorder to true or false respectfully.

*/
public  void safeBorderOn() {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_safeBorderOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::GrayscaleMorphologicalClosingImageFilter::SafeBorderOff()
*/
public  void safeBorderOff() {
    SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_safeBorderOff(swigCPtr, this);
  }

  /**
bool itk::simple::GrayscaleMorphologicalClosingImageFilter::GetSafeBorder() const

A safe border is added to input image to avoid borders effects and
remove it once the closing is done

*/
public  boolean getSafeBorder() {
    return SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_getSafeBorder(swigCPtr, this);
  }

  /**
std::string itk::simple::GrayscaleMorphologicalClosingImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::GrayscaleMorphologicalClosingImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::GrayscaleMorphologicalClosingImageFilter::Execute(const Image &amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.GrayscaleMorphologicalClosingImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
