/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Computes the Laplacian of Gaussian (LoG) of an image.


Computes the Laplacian of Gaussian (LoG) of an image by convolution
with the second derivative of a Gaussian. This filter is implemented
using the recursive gaussian filters.
See:
 itk::simple::LaplacianRecursiveGaussian for the procedural interface

 itk::LaplacianRecursiveGaussianImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkLaplacianRecursiveGaussianImageFilter.h
*/
public class LaplacianRecursiveGaussianImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected LaplacianRecursiveGaussianImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(LaplacianRecursiveGaussianImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(LaplacianRecursiveGaussianImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::LaplacianRecursiveGaussianImageFilter::~LaplacianRecursiveGaussianImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_LaplacianRecursiveGaussianImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::LaplacianRecursiveGaussianImageFilter::LaplacianRecursiveGaussianImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  LaplacianRecursiveGaussianImageFilter() {
    this(SimpleITKJNI.new_LaplacianRecursiveGaussianImageFilter(), true);
  }

  /**
Self&amp; itk::simple::LaplacianRecursiveGaussianImageFilter::SetSigma(double Sigma)

Set/Get Sigma value. Sigma is measured in the units of image spacing.

*/
public  void setSigma(double Sigma) {
    SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_setSigma(swigCPtr, this, Sigma);
  }

  /**
double itk::simple::LaplacianRecursiveGaussianImageFilter::GetSigma() const

Set/Get Sigma value. Sigma is measured in the units of image spacing.

*/
public  double getSigma() {
    return SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_getSigma(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::LaplacianRecursiveGaussianImageFilter::SetNormalizeAcrossScale(bool NormalizeAcrossScale)

Define which normalization factor will be used for the Gaussian
See:
 RecursiveGaussianImageFilter::SetNormalizeAcrossScale


*/
public  void setNormalizeAcrossScale(boolean NormalizeAcrossScale) {
    SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_setNormalizeAcrossScale(swigCPtr, this, NormalizeAcrossScale);
  }

  /**
Self&amp; itk::simple::LaplacianRecursiveGaussianImageFilter::NormalizeAcrossScaleOn()

Set the value of NormalizeAcrossScale to true or false respectfully.

*/
public  void normalizeAcrossScaleOn() {
    SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_normalizeAcrossScaleOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::LaplacianRecursiveGaussianImageFilter::NormalizeAcrossScaleOff()
*/
public  void normalizeAcrossScaleOff() {
    SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_normalizeAcrossScaleOff(swigCPtr, this);
  }

  /**
bool itk::simple::LaplacianRecursiveGaussianImageFilter::GetNormalizeAcrossScale() const

Define which normalization factor will be used for the Gaussian
See:
 RecursiveGaussianImageFilter::SetNormalizeAcrossScale


*/
public  boolean getNormalizeAcrossScale() {
    return SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_getNormalizeAcrossScale(swigCPtr, this);
  }

  /**
std::string itk::simple::LaplacianRecursiveGaussianImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::LaplacianRecursiveGaussianImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::LaplacianRecursiveGaussianImageFilter::Execute(const Image &amp;image1)

Execute the filter on the input image

*/
public  Image execute(Image image1) {
    return new Image(SimpleITKJNI.LaplacianRecursiveGaussianImageFilter_execute(swigCPtr, this, Image.getCPtr(image1), image1), true);
  }

}
