/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Threshold an image using the Moments Threshold.


This filter creates a binary thresholded image that separates an image
into foreground and background components. The filter computes the
threshold using the MomentsThresholdCalculator and applies that threshold to the input image using the BinaryThresholdImageFilter .


Richard Beare. Department of Medicine, Monash University, Melbourne,
Australia.

Gaetan Lehmann. Biologie du Developpement et de la Reproduction, INRA
de Jouy-en-Josas, France.
 This implementation was taken from the Insight Journal paper: https://www.insight-journal.org/browse/publication/811


See:
 HistogramThresholdImageFilter

 itk::simple::MomentsThreshold for the procedural interface

 itk::MomentsThresholdImageFilter for the Doxygen on the original ITK class.


C++ includes: sitkMomentsThresholdImageFilter.h
*/
public class MomentsThresholdImageFilter extends ImageFilter {
  private transient long swigCPtr;

  protected MomentsThresholdImageFilter(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.MomentsThresholdImageFilter_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(MomentsThresholdImageFilter obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(MomentsThresholdImageFilter obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::MomentsThresholdImageFilter::~MomentsThresholdImageFilter()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_MomentsThresholdImageFilter(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::MomentsThresholdImageFilter::MomentsThresholdImageFilter()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  MomentsThresholdImageFilter() {
    this(SimpleITKJNI.new_MomentsThresholdImageFilter(), true);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::SetInsideValue(uint8_t InsideValue)

Set the "inside" pixel value.

*/
public  void setInsideValue(short InsideValue) {
    SimpleITKJNI.MomentsThresholdImageFilter_setInsideValue(swigCPtr, this, InsideValue);
  }

  /**
uint8_t itk::simple::MomentsThresholdImageFilter::GetInsideValue() const

Get the "inside" pixel value.

*/
public  short getInsideValue() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getInsideValue(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::SetOutsideValue(uint8_t OutsideValue)

Set the "outside" pixel value. The default value NumericTraits&lt;OutputPixelType&gt;::Zero.

*/
public  void setOutsideValue(short OutsideValue) {
    SimpleITKJNI.MomentsThresholdImageFilter_setOutsideValue(swigCPtr, this, OutsideValue);
  }

  /**
uint8_t itk::simple::MomentsThresholdImageFilter::GetOutsideValue() const

Get the "outside" pixel value.

*/
public  short getOutsideValue() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getOutsideValue(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::SetNumberOfHistogramBins(uint32_t NumberOfHistogramBins)

Set/Get the number of histogram bins.

*/
public  void setNumberOfHistogramBins(long NumberOfHistogramBins) {
    SimpleITKJNI.MomentsThresholdImageFilter_setNumberOfHistogramBins(swigCPtr, this, NumberOfHistogramBins);
  }

  /**
uint32_t itk::simple::MomentsThresholdImageFilter::GetNumberOfHistogramBins() const
*/
public  long getNumberOfHistogramBins() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getNumberOfHistogramBins(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::SetMaskOutput(bool MaskOutput)

Do you want the output to be masked by the mask used in histogram
construction. Only relevant if masking is in use.

*/
public  void setMaskOutput(boolean MaskOutput) {
    SimpleITKJNI.MomentsThresholdImageFilter_setMaskOutput(swigCPtr, this, MaskOutput);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::MaskOutputOn()

Set the value of MaskOutput to true or false respectfully.

*/
public  void maskOutputOn() {
    SimpleITKJNI.MomentsThresholdImageFilter_maskOutputOn(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::MaskOutputOff()
*/
public  void maskOutputOff() {
    SimpleITKJNI.MomentsThresholdImageFilter_maskOutputOff(swigCPtr, this);
  }

  /**
bool itk::simple::MomentsThresholdImageFilter::GetMaskOutput() const
*/
public  boolean getMaskOutput() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getMaskOutput(swigCPtr, this);
  }

  /**
Self&amp; itk::simple::MomentsThresholdImageFilter::SetMaskValue(uint8_t MaskValue)

The value in the mask image, if used, indicating voxels that should be
included. Default is the max of pixel type, as in the
MaskedImageToHistogramFilter

*/
public  void setMaskValue(short MaskValue) {
    SimpleITKJNI.MomentsThresholdImageFilter_setMaskValue(swigCPtr, this, MaskValue);
  }

  /**
uint8_t itk::simple::MomentsThresholdImageFilter::GetMaskValue() const
*/
public  short getMaskValue() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getMaskValue(swigCPtr, this);
  }

  /**
double itk::simple::MomentsThresholdImageFilter::GetThreshold() const

Get the computed threshold.


This is a measurement. Its value is updated in the Execute methods, so
the value will only be valid after an execution.

*/
public  double getThreshold() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getThreshold(swigCPtr, this);
  }

  /**
std::string itk::simple::MomentsThresholdImageFilter::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.MomentsThresholdImageFilter_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::MomentsThresholdImageFilter::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.MomentsThresholdImageFilter_toString(swigCPtr, this);
  }

  /**
Image itk::simple::MomentsThresholdImageFilter::Execute(const Image &amp;image, const Image &amp;maskImage)

Execute the filter on the input image

*/
public  Image execute(Image image, Image maskImage) {
    return new Image(SimpleITKJNI.MomentsThresholdImageFilter_execute__SWIG_0(swigCPtr, this, Image.getCPtr(image), image, Image.getCPtr(maskImage), maskImage), true);
  }

  /**
Image itk::simple::MomentsThresholdImageFilter::Execute(const Image &amp;image, const Image &amp;maskImage)

Execute the filter on the input image

*/
public  Image execute(Image image) {
    return new Image(SimpleITKJNI.MomentsThresholdImageFilter_execute__SWIG_1(swigCPtr, this, Image.getCPtr(image), image), true);
  }

}
