/* ----------------------------------------------------------------------------
 * This file was automatically generated by SWIG (https://www.swig.org).
 * Version 4.1.1
 *
 * Do not make changes to this file unless you know what you are doing - modify
 * the SWIG interface file instead.
 * ----------------------------------------------------------------------------- */

package org.itk.simple;
/**

Generate an image of the physical locations of each pixel.


This image source supports image which have a multi-component pixel
equal to the image dimension, and variable length VectorImages. It is
recommended that the component type be a real valued type.
See:
 itk::simple::PhysicalPointSource for the procedural interface

 itk::PhysicalPointImageSource for the Doxygen on the original ITK class.


C++ includes: sitkPhysicalPointImageSource.h
*/
public class PhysicalPointImageSource extends ImageFilter {
  private transient long swigCPtr;

  protected PhysicalPointImageSource(long cPtr, boolean cMemoryOwn) {
    super(SimpleITKJNI.PhysicalPointImageSource_SWIGUpcast(cPtr), cMemoryOwn);
    swigCPtr = cPtr;
  }

  protected static long getCPtr(PhysicalPointImageSource obj) {
    return (obj == null) ? 0 : obj.swigCPtr;
  }

  protected static long swigRelease(PhysicalPointImageSource obj) {
    long ptr = 0;
    if (obj != null) {
      if (!obj.swigCMemOwn)
        throw new RuntimeException("Cannot release ownership as memory is not owned");
      ptr = obj.swigCPtr;
      obj.swigCMemOwn = false;
      obj.delete();
    }
    return ptr;
  }

  @SuppressWarnings("deprecation")
  protected void finalize() {
    delete();
  }

  /**
virtual itk::simple::PhysicalPointImageSource::~PhysicalPointImageSource()

Destructor

*/
public  void delete() {
    if (swigCPtr != 0) {
      if (swigCMemOwn) {
        swigCMemOwn = false;
        SimpleITKJNI.delete_PhysicalPointImageSource(swigCPtr);
      }
      swigCPtr = 0;
    }
    super.delete();
  }

  /**
itk::simple::PhysicalPointImageSource::PhysicalPointImageSource()

Default Constructor that takes no arguments and initializes default
parameters

*/
public  PhysicalPointImageSource() {
    this(SimpleITKJNI.new_PhysicalPointImageSource(), true);
  }

  /**
Self&amp; itk::simple::PhysicalPointImageSource::SetOutputPixelType(PixelIDValueEnum OutputPixelType)
*/
public  void setOutputPixelType(PixelIDValueEnum OutputPixelType) {
    SimpleITKJNI.PhysicalPointImageSource_setOutputPixelType(swigCPtr, this, OutputPixelType.swigValue());
  }

  /**
PixelIDValueEnum itk::simple::PhysicalPointImageSource::GetOutputPixelType() const
*/
public  PixelIDValueEnum getOutputPixelType() {
    return PixelIDValueEnum.swigToEnum(SimpleITKJNI.PhysicalPointImageSource_getOutputPixelType(swigCPtr, this));
  }

  /**
Self&amp; itk::simple::PhysicalPointImageSource::SetSize(std::vector&lt; unsigned int &gt; Size)
*/
public  void setSize(VectorUInt32 Size) {
    SimpleITKJNI.PhysicalPointImageSource_setSize(swigCPtr, this, VectorUInt32.getCPtr(Size), Size);
  }

  /**
std::vector&lt;unsigned int&gt; itk::simple::PhysicalPointImageSource::GetSize() const
*/
public  VectorUInt32 getSize() {
    return new VectorUInt32(SimpleITKJNI.PhysicalPointImageSource_getSize(swigCPtr, this), true);
  }

  /**
Self&amp; itk::simple::PhysicalPointImageSource::SetOrigin(std::vector&lt; double &gt; Origin)
*/
public  void setOrigin(VectorDouble Origin) {
    SimpleITKJNI.PhysicalPointImageSource_setOrigin(swigCPtr, this, VectorDouble.getCPtr(Origin), Origin);
  }

  /**
std::vector&lt;double&gt; itk::simple::PhysicalPointImageSource::GetOrigin() const
*/
public  VectorDouble getOrigin() {
    return new VectorDouble(SimpleITKJNI.PhysicalPointImageSource_getOrigin(swigCPtr, this), true);
  }

  /**
Self&amp; itk::simple::PhysicalPointImageSource::SetSpacing(std::vector&lt; double &gt; Spacing)
*/
public  void setSpacing(VectorDouble Spacing) {
    SimpleITKJNI.PhysicalPointImageSource_setSpacing(swigCPtr, this, VectorDouble.getCPtr(Spacing), Spacing);
  }

  /**
std::vector&lt;double&gt; itk::simple::PhysicalPointImageSource::GetSpacing() const
*/
public  VectorDouble getSpacing() {
    return new VectorDouble(SimpleITKJNI.PhysicalPointImageSource_getSpacing(swigCPtr, this), true);
  }

  /**
Self&amp; itk::simple::PhysicalPointImageSource::SetDirection(std::vector&lt; double &gt; Direction)
*/
public  void setDirection(VectorDouble Direction) {
    SimpleITKJNI.PhysicalPointImageSource_setDirection(swigCPtr, this, VectorDouble.getCPtr(Direction), Direction);
  }

  /**
std::vector&lt;double&gt; itk::simple::PhysicalPointImageSource::GetDirection() const
*/
public  VectorDouble getDirection() {
    return new VectorDouble(SimpleITKJNI.PhysicalPointImageSource_getDirection(swigCPtr, this), true);
  }

  /**
std::string itk::simple::PhysicalPointImageSource::GetName() const

Name of this class

*/
public  String getName() {
    return SimpleITKJNI.PhysicalPointImageSource_getName(swigCPtr, this);
  }

  /**
std::string itk::simple::PhysicalPointImageSource::ToString() const

Print ourselves out

*/
public  String toString() {
    return SimpleITKJNI.PhysicalPointImageSource_toString(swigCPtr, this);
  }

  /**
Image itk::simple::PhysicalPointImageSource::Execute()

Execute the filter on the input image

*/
public  Image execute() {
    return new Image(SimpleITKJNI.PhysicalPointImageSource_execute(swigCPtr, this), true);
  }

  /**
void itk::simple::PhysicalPointImageSource::SetReferenceImage(const Image &amp;refImage)

This methods sets the size, origin, spacing and direction to that of
the provided image

*/
public  void setReferenceImage(Image refImage) {
    SimpleITKJNI.PhysicalPointImageSource_setReferenceImage(swigCPtr, this, Image.getCPtr(refImage), refImage);
  }

}
